;(require-library simple-loops simple-tests)
(import simple-loops simple-tests)

(define-test (loops?)
  (equal?
    (let ((lst '()))
      (do-times (k (+ 2 3))
        (set! lst (cons k lst)))
      lst)
    '(4 3 2 1 0))
  (equal?
    (let ((lst '()))
      ;; deprecated syntax
      (do-times k (+ 2 3)
        (set! lst (cons k lst)))
      lst)
    '(4 3 2 1 0))
  (equal?
    (let ((lst '()))
      (do-list (var '(1 2 3))
        (set! lst (cons var lst)))
      lst)
    '(3 2 1))
  (equal?
    (let ((lst '()))
      ;; deprecated syntax
      (do-list var '(1 2 3)
        (set! lst (cons var lst)))
      lst)
    '(3 2 1))
  (equal?
    (let ((lst '()))
      (do-for (var 1 5) (set! lst (cons var lst)))
      (reverse lst))
    '(1 2 3 4))
  (equal?
    (let ((lst '()))
      ;; deprecated syntax
      (do-for var (1 5) (set! lst (cons var lst)))
      (reverse lst))
    '(1 2 3 4))
  (equal?
    (let ((lst '()))
      (do-for (var 1 65 var) (set! lst (cons var lst)))
      (reverse lst))
    '(1 2 4 8 16 32 64))
  (equal?
    (let ((lst '()))
      ;; deprecated syntax
      (do-for var (1 65 var) (set! lst (cons var lst)))
      (reverse lst))
    '(1 2 4 8 16 32 64))
  (equal?
    (let ((n 4) (lst '()))
      (do-while (<= 0 n)
        (set! lst (cons n lst))
        (set! n (- n 1)))
      lst)
    '(0 1 2 3 4))
  (equal?
    (let ((n 4) (lst '()))
      (do-until (> 0 n)
        (set! lst (cons n lst))
        (set! n (- n 1)))
      lst)
    '(0 1 2 3 4))
  (equal?
    (let ((n 3) (lst '()))
      (do-forever
        (if (zero? n) (exit lst))
        (set! lst (cons 'a lst))
        (set! n (- n 1))))
    '(a a a))
  )

(compound-test (LOOPS)
  (loops?))
